//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "ConsoleWin.h"
#include "time.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TConsole *Console;
//---------------------------------------------------------------------------
int __fastcall RunConsoleApp(TForm *Owner, const AnsiString &Cmdline)
{
   Console = new TConsole(Owner,Cmdline,SW_SHOWNORMAL);
   Console->Run();
   delete Console;
   return 0;
}
//---------------------------------------------------------------------------
__fastcall TConsole::TConsole(TComponent* Owner) :
   TForm(Owner)
{
}
//---------------------------------------------------------------------------
__fastcall TConsole::TConsole(TComponent* Owner, const AnsiString &Cmdline, WORD ShowCmd) :
   TForm(Owner)
{
    consoleapp = new TConsoleApp(Cmdline,Display->Lines,ShowCmd);
    working = false;
}
//---------------------------------------------------------------------------
void __fastcall TConsole::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   if (working)
   {
      MessageBeep(MB_OK);
      CanClose = false;
   }
}
//---------------------------------------------------------------------------
__fastcall TConsoleApp::TConsoleApp(const AnsiString &Cmdline, TStrings *Output, WORD ShowCmd)
{
   showcmd = ShowCmd;
   cmdline = Cmdline;
   exitproc = false;
   exitcode = 0;
   exitwait = 0;
   output = Output;
}
//---------------------------------------------------------------------------
__fastcall TConsoleApp::~TConsoleApp()
{
}
//---------------------------------------------------------------------------
// used by RunConsoleApp {below}
bool __fastcall TConsoleApp::readfile(HANDLE hReadPipe)
{
   static char buf[1024];
   static AnsiString incomingline;
   unsigned long len,bufsize = sizeof(buf)-1;
   ReadFile(hReadPipe,buf,bufsize,&len, NULL);
   if (len>1)
   {
      for (unsigned i=0; i<len; i++)
      {
         if (buf[i]!='\0' && buf[i]!='\n' && buf[i]!='\r')
            incomingline += String(buf[i]);
         if (buf[i]=='\n')
         {
            output->Add(incomingline);
            incomingline.SetLength(0);
         }
      }
   }
   if (len<bufsize) return false;
   return true;
}
//---------------------------------------------------------------------------
/*
void __fastcall TConsoleApp::Run()
{
   STARTUPINFO sui;
   PROCESS_INFORMATION pi;
   SECURITY_ATTRIBUTES sa;
   HANDLE hReadPipe, hWritePipe;
   // setup the stdout
   // first create the sec attrib
   sa.nLength = sizeof (SECURITY_ATTRIBUTES);
   sa.lpSecurityDescriptor = NULL;
   sa.bInheritHandle = true;
   // create pipe handles
   CreatePipe(&hReadPipe, &hWritePipe, &sa, 2500000);
   if (hReadPipe == INVALID_HANDLE_VALUE || hWritePipe == INVALID_HANDLE_VALUE)
   {
      MessageBox(NULL,"Not a valid Handle for STDOUT",NULL,MB_OK|MB_ICONEXCLAMATION);
      return;
   }
   // setup the start up info
   memset(&sui, 0, sizeof(STARTUPINFO));
   sui.cb = sizeof (STARTUPINFO);
   sui.lpReserved = NULL;
   sui.lpDesktop = NULL;
   sui.lpTitle = NULL;
   sui.lpReserved2 = NULL;
   sui.cbReserved2 = 0;
   sui.dwFlags = STARTF_USESTDHANDLES | STARTF_USESHOWWINDOW;
   sui.wShowWindow = SW_MINIMIZE;
   sui.hStdOutput = hWritePipe;
   sui.hStdError = hWritePipe;
   if (!CreateProcess (NULL,
      cmdline.c_str(),   	// pointer to command line string
      NULL, 		// pointer to process security attributes, we don't need to inherit the handle
      NULL, 		// pointer to thread security attributes
      true,  		// handle inheritance flag
      0,  		   // creation flags
      NULL, 		// pointer to new environment block
      NULL, 		// pointer to current directory name
     &sui,   		// pointer to STARTUPINFO
     &pi 			// pointer to PROCESS_INFORMATION
   ))
   {
      MessageBox(NULL,"Could not create process", NULL, MB_OK | MB_ICONEXCLAMATION);
      return;
   }
   CloseHandle(pi.hThread);

   int ms=500;
   int done=0;
   DWORD bt,xcode;
   while (++done<30000)
   {
      Application->ProcessMessages();
      if (GetExitCodeProcess(pi.hProcess,&xcode) && xcode != STILL_ACTIVE) break;
      if (WaitForSingleObject(pi.hProcess,ms) != WAIT_TIMEOUT) break;
      while (PeekNamedPipe(hReadPipe,NULL,NULL,NULL,&bt,NULL) && bt)
      {
         Application->ProcessMessages();
         readfile(hReadPipe);
      }
   }
   while (PeekNamedPipe(hReadPipe,NULL,NULL,NULL,&bt,NULL) && bt)
   {
      Application->ProcessMessages();
      readfile(hReadPipe);
   }
   if (!unattended) MessageBeep(MB_OK);
   Sleep(1000);
   return;
}
*/
//---------------------------------------------------------------------------
AnsiString __fastcall GetLastErrorString()
{
   DWORD result = GetLastError();
   LPVOID lpMsgBuf;
   FormatMessage(
      FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM,
      NULL,
      result,
      MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
     (LPTSTR) &lpMsgBuf,
      0,
      NULL
   );
   return AnsiString((char*)lpMsgBuf);
}
//---------------------------------------------------------------------------
void __fastcall TConsoleApp::Run()
{
   STARTUPINFO sui;
   PROCESS_INFORMATION pi;
   SECURITY_ATTRIBUTES sa;
   HANDLE hReadPipe, hWritePipe;
   // setup the stdout
   // first create the sec attrib
   sa.nLength = sizeof (SECURITY_ATTRIBUTES);
   sa.lpSecurityDescriptor = NULL;
   sa.bInheritHandle = true;
   // create pipe handles
   CreatePipe(&hReadPipe, &hWritePipe, &sa, 2500000);
   if (hReadPipe == INVALID_HANDLE_VALUE || hWritePipe == INVALID_HANDLE_VALUE)
   {
      MessageBox(NULL,"Not a valid Handle for STDOUT",NULL,MB_OK|MB_ICONEXCLAMATION);
      return;
   }
   // setup the start up info
   memset(&sui, 0, sizeof(STARTUPINFO));
   sui.cb = sizeof (STARTUPINFO);
   sui.lpReserved = NULL;
   sui.lpDesktop = NULL;
   sui.lpTitle = NULL;
   sui.lpReserved2 = NULL;
   sui.cbReserved2 = 0;
   sui.dwFlags = STARTF_USESTDHANDLES | STARTF_USESHOWWINDOW;
   sui.wShowWindow = showcmd;
   sui.hStdOutput = hWritePipe;
   sui.hStdError = hWritePipe;
   if (!CreateProcess (NULL,
      cmdline.c_str(),   	// pointer to command line string
      NULL, 		// pointer to process security attributes, we don't need to inherit the handle
      NULL, 		// pointer to thread security attributes
      true,  		// handle inheritance flag
      0,  		   // creation flags
      NULL, 		// pointer to new environment block
      NULL, 		// pointer to current directory name
     &sui,   		// pointer to STARTUPINFO
     &pi 			// pointer to PROCESS_INFORMATION
   ))
   {
      MessageBox(NULL,"Could not create process", NULL, MB_OK | MB_ICONEXCLAMATION);
      return;
   }
   CloseHandle(pi.hThread);

   DWORD bt;
   int ms=1000;
   timeout=false;
   time_t marktime=time(NULL);
   while (time(NULL)<marktime+30)
   {
      Application->ProcessMessages();
      // if this wait fails go straight to errorstr
      if ((exitwait=WaitForSingleObject(pi.hProcess,ms))!=WAIT_FAILED)
      {
         Application->ProcessMessages();
         while (PeekNamedPipe(hReadPipe,NULL,NULL,NULL,&bt,NULL) && bt)
         {
            Application->ProcessMessages();
            readfile(hReadPipe);
         }
         marktime = time(NULL);
      }
      if (exitwait==WAIT_FAILED || !(exitproc=GetExitCodeProcess(pi.hProcess,&exitcode)))
         errorstr=GetLastErrorString();
      if (!errorstr.IsEmpty() || exitwait!=WAIT_TIMEOUT) break;
   }
   timeout=time(NULL)>=marktime+30;
   return;
}
//---------------------------------------------------------------------------
void __fastcall TConsole::Timer1Timer(TObject *Sender)
{
   Timer1->Enabled = false;
   consoleapp->Run();
}
//---------------------------------------------------------------------------
void __fastcall TConsole::FormDestroy(TObject *Sender)
{
   delete consoleapp;
}
//---------------------------------------------------------------------------
void __fastcall TConsole::FormShow(TObject *Sender)
{
   Timer1->Enabled = true;
}
//---------------------------------------------------------------------------
int __fastcall TConsole::Run()
{
    FormShow(this);
    return 0;
}
//---------------------------------------------------------------------------
