//---------------------------------------------------------------------------
#ifndef MixmasterH
#define MixmasterH

#include <vcl/comctrls.hpp>
//---------------------------------------------------------------------------
const AnsiString MixKey = "Software\\Mixmaster";
const AnsiString MixExe = "mix.exe";
const AnsiString MixTmp = "mix.tmp.QS";
const AnsiString MixCfg = "mix.cfg";
const AnsiString MixOut = "out*.txt";
const AnsiString DefMixCfg =
   "###### Client Config ######\r\nSENDMAIL outfile\r\nERRLOG errlog\r\nREMAIL n";

#define QUEUEDIRECTORY  String(MixDir()+"pool\\")
#define QUEUEFILES  String(QUEUEDIRECTORY+MixOut)

AnsiString __fastcall MixDir();
bool __fastcall HasMixmaster();
bool __fastcall HasMix();

typedef unsigned char byte;
typedef struct {
  byte *data;
  long length;
  long ptr;
  long size;
  byte sensitive;
} BUFFER;

int buf_readfile(BUFFER *buffer, char *filename);
int buf_writefile(BUFFER *buffer, char *filename, char* mode);  // mode = 'wb' or 'wt'

int __fastcall mix_encrypt(int type, BUFFER *message, char *chain, int numcopies,
		BUFFER *feedback);
int __fastcall mix_encrypt_exe(int type, BUFFER *message, char *chain, int numcopies,
   BUFFER *feedback, bool *cancel, TProgressBar *progressbar);

BUFFER* __fastcall buf_new(void);
int __fastcall buf_free(BUFFER *buf);
int __fastcall buf_reset(BUFFER *buf);
int __fastcall buf_append(BUFFER *buffer, byte *mess, int len);
int __fastcall buf_sets(BUFFER *buffer, char *s);
void __fastcall buf_move(BUFFER *dest, BUFFER *src);
int __fastcall buf_write(BUFFER *buffer, FILE *out);
int __fastcall mix_send(void);
int __fastcall pgp_encrypt(int mode, BUFFER *message, BUFFER *encr, BUFFER *sigid,
		BUFFER *pass, char *pubring, char *secring);
int __fastcall pgp_mailenc(int mode, BUFFER *message, char *sigid,
		BUFFER *pass, char *pubring, char *secring);
int __fastcall pgp_decrypt(BUFFER *message, BUFFER *pass, BUFFER *sig, char *pubring,
		char *secring);

int __fastcall rnd_add(byte *b, long len);
void __fastcall rnd_time();
int __fastcall rnd_mouse(UINT i, WPARAM w, LPARAM l);
int __fastcall buf_getline(BUFFER *buffer, BUFFER *line);
int __fastcall buf_getheader(BUFFER *buffer, BUFFER *field, BUFFER *content);

// internal use for accessing dll function with run-time binding
typedef BUFFER* (*BUF_NEW)(void);
typedef int (*BUF_FREE)(BUFFER*);
typedef int (*BUF_RESET)(BUFFER*);
typedef int (*BUF_APPEND)(BUFFER*, byte*, int);
typedef int (*BUF_SETS)(BUFFER*, char *);
typedef void(*BUF_MOVE)(BUFFER*, BUFFER*);
typedef int (*BUF_WRITE)(BUFFER*, FILE*);
typedef int (*MIX_ENCRYPT)(int, BUFFER*, char*, int, BUFFER*);
typedef int (*MIX_SEND)(void);
typedef int (*PGP_ENCRYPT_BUF)(int, BUFFER*, BUFFER*, BUFFER*, BUFFER*, char*, char*);
typedef int (*PGP_MAILENC_BUF)(int, BUFFER*, char*, BUFFER*, char*, char*);

typedef int (*PGP_DECRYPT)(BUFFER*, BUFFER*, BUFFER*, char*, char*);

typedef int (*RND_ADD)(byte*,long);

typedef void (*RND_TIME)(void);

typedef int (*RND_MOUSE)(UINT, WPARAM, LPARAM);

typedef int (*BUF_GETLINE)(BUFFER*, BUFFER*);
typedef int (*BUF_GETHEADER)(BUFFER*, BUFFER*, BUFFER*);

#define MSG_MAIL 1
#define PGP_PASS -2
#define PGP_ERR -1
#define PGP_SIGN 1
#define PGP_ENCRYPT 2
#define PGP_TEXT 16
#define PGP_REMAIL 8
#define PGP_CONVENTIONAL 4
#define PGP_NOARMOR 32
#define BUFFER_MAX 2*1024*1024
#define BUFSIZE 4096
#define MixRandBin MixDir()+"mixrand.bin"
#define MixRandPool AnsiString("RandomPool")
//---------------------------------------------------------------------------
extern HINSTANCE hMixLib;
//---------------------------------------------------------------------------
#endif
