//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "MsgInWin.h"
#include "MsgWin.h"
#include "MBoxWin.h"
#include "FileMan.h"
#include "global.h"
#include "MixmastDlg.h"
#include "Mixmaster.h"
//#include "PassDlg.h"
#include "PGPpassEx.h"
#include "clipreply.h"
#include "pop3mail.h"
#include "savedlg.h"
#include "picboxdlg.h"
//---------------------------------------------------------------------------
#pragma link "NoteWin"
#pragma resource "*.dfm"
TMessageInWin *MessageInWin;
//---------------------------------------------------------------------------
bool __fastcall OpenMessageIn(AnsiString &MailBox, AnsiString &IndexStr)
{
   if (MailBox.IsEmpty() || IndexStr.IsEmpty()) return false;
   MessageInWin = new TMessageInWin(MailBox,IndexStr,Application->MainForm);
   return true;
}
//---------------------------------------------------------------------------
__fastcall TMessageInWin::TMessageInWin(TComponent* Owner)
  : TTextWin(Owner)
{
}
//---------------------------------------------------------------------------
__fastcall TMessageInWin::TMessageInWin(AnsiString &MailBox, AnsiString &Indexstr,
   TComponent* Owner) : TTextWin(Owner)
{
   Type = tInMessage;
   Mailbox = MailBox;
   IndexStr = Indexstr;
   DataKey = UserMailboxes+PS+Mailbox+PS+IndexStr;
   GetAppData(Editor->Lines,DataKey);
   Headers = new THeaderManager(Editor->Lines);
   SetMessage();
}
//---------------------------------------------------------------------------
__fastcall TMessageInWin::~TMessageInWin()
{
   delete Headers;
}
//---------------------------------------------------------------------------
void __fastcall TMessageInWin::SetNoMixmaster()
{
   PGPcdecBtn->Visible = false;
   WordWrap->Left -= 32;
}
//---------------------------------------------------------------------------
void __fastcall TMessageInWin::SetMessage()
{
   AnsiString cap=IndexStr+" ",fs=FieldSep,ic=InCode;
 //change caption to remove markers===
   for (int i=1; i<=cap.Length(); i++)
      if (cap[i]==fs[1] || cap[i]==ic[1]) cap[i]=' ';
   cap = cap.Trim();
   while (cap.Length() && cap[cap.Length()]!=' ') cap.SetLength(cap.Length()-1);
 //=====================================================
   Editor->ReadOnly = true;
   FullHeaders = false;
   TStringList *tmp = new TStringList();
   tmp->Text = Editor->Lines->Text;
   Editor->Clear(); Sleep(200);
   bool locked=LockWindowUpdate(Handle);
   Editor->WordWrap = false;
   HeadersBtn->Hint = "Show minimum headers";
   Editor->Lines->Text = tmp->Text;
   delete tmp;
   Caption = Mailbox+": "+cap;
   if (locked) LockWindowUpdate(0);
   // handle status change
   TMailboxWin *box=FindOpenMailbox(Mailbox);
   if (box) locked=LockWindowUpdate(box->MailGrid->Handle);
   if (GetMsgStatus(DataKey)=='N') SetMsgStatus(DataKey,' ');
   if (box && locked) LockWindowUpdate(0);
   // check for special header treatment
   locked=LockWindowUpdate(Handle);
   if (NoHeaders->Checked)
   {
      while (!Headers->PopHeader().IsEmpty()) Application->ProcessMessages();
      Editor->Lines->Delete(0);
   }
   else
   if (!FullHeaders)
   {
      HeadersBtn->Hint = "Show all message headers";
      TStringList *msghdrs = new TStringList();
      msghdrs->Add("Date: ");
      msghdrs->Add("From: ");
      msghdrs->Add("Comments: ");
      msghdrs->Add("To: ");
      msghdrs->Add("Cc: ");
      msghdrs->Add("Subject: ");

      AnsiString mdr,hdr;
      TStringList *hdrs = new TStringList();
      for (int i=msghdrs->Count-1; i>=0; i--)
      {
         mdr = msghdrs->Strings[i]; // get as many of each as exists
         while (!(hdr=Headers->GetDat(mdr)).IsEmpty()) // thinking mostly of 'From: '
         {
            if (mdr.Pos("Subject: ")==1 && hdr.IsEmpty()) hdr = "Re:";
            hdrs->Insert(0,mdr+hdr);
            Headers->Delete(mdr);
         }
      }
      while (!Headers->PopHeader().IsEmpty()) Application->ProcessMessages();
      Editor->Lines->Delete(0);
      Editor->Lines->Insert(0,hdrs->Text);
      delete hdrs;
   }
   if (locked) LockWindowUpdate(0);
   Editor->Modified = false;
   Editor->SelStart = 0;
   if (!HasMix()) SetNoMixmaster();
   else
      PGPcdecBtn->Enabled =
         Editor->Lines->Text.Pos("-----BEGIN PGP MESSAGE-----")>0;
   HeadersBtn->Enabled = true;
}
//---------------------------------------------------------------------------
int eohm(TStrings *msg)
{
   int e=0; while (e<msg->Count && !msg->Strings[e].IsEmpty()) e++;
   return e;
}
//---------------------------------------------------------------------------
void __fastcall TMessageInWin::CreateReply(bool UseDialog)
{
   AnsiString TemplateName=DefaultMessage,inreplyto;
   if (UseDialog && ((TemplateName=GetMergeMessage("Reply using...",modeMessage))).IsEmpty()) return;
   if (GetMsgStatus(DataKey)==' ')
   {
      SetMsgStatus(DataKey,'R');
      inreplyto = DataKey;
   }
   ReplyToMessage(Editor->Lines,TemplateName,inreplyto);
}
//---------------------------------------------------------------------------
void __fastcall TMessageInWin::HeadersBtnClick(TObject *Sender)
{
   if (EditBtn->Down)
   {
      HeadersBtn->Down = true;
      return;
   }
   FullHeaders = HeadersBtn->Down;
   SetMessage();
}
//---------------------------------------------------------------------------
void __fastcall TMessageInWin::ReplyBtnClick(TObject *Sender)
{
   CreateReply(true);
}
//---------------------------------------------------------------------------
void __fastcall TMessageInWin::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   if (Editor->Modified && !CheckSave())
   {
      CanClose = false;
      return;
   }
   if (MDIChildCount==0) SetParentButtons(false);
   ShowCurXY(false);
}
//---------------------------------------------------------------------------
bool __fastcall TMessageInWin::CheckSave()
{
   bool ok = true;
   if (Editor->Modified)
   {
      int reply = MsgBoxHwnd(Handle,"Save changes to message?",
         "Save Message",MB_YESNOCANCEL);
      switch(reply)
      {
         case IDCANCEL: ok = false; break;
         case IDYES: Save(); break;
      }
   }
   return ok;
}
//---------------------------------------------------------------------------
bool __fastcall TMessageInWin::Save()
{
   AnsiString path,spath,pgphdr;
   TStringList *lines = new TStringList();
   lines->Text = Editor->Lines->Text; Editor->Clear();

   bool locked=LockWindowUpdate(Handle);
   PutAppData(DataKey,lines);
   Editor->Lines->Text = lines->Text;
   Editor->Modified = false;
   Editor->SelStart = 0;
   Sleep(100);
   SetMessage();
   if (locked) LockWindowUpdate(0);

   AnsiString shomsg = Caption+" ... saved!";
   Application->MainForm->Perform(WM_SHOWSTATUS,0,(LPARAM)shomsg.c_str());
   delete lines;
   return true;
}
//---------------------------------------------------------------------------
bool __fastcall TMessageInWin::SaveAs()
{
   bool locked,ok=false;
   AnsiString name,Section=UserMessages;

   AnsiString path,pgphdr;
   path = GetSaveMessagePath(Section+"only",Name());
   if (!path.IsEmpty())
   {
      DataKey = path;
      locked = LockWindowUpdate(Handle);
      // save message
      PutAppData(DataKey,Editor->Lines); Editor->Clear();
      if (locked) LockWindowUpdate(0);
      Application->ProcessMessages();
      Sleep(100);
      // reload message
      locked = LockWindowUpdate(Handle);
      GetAppData(Editor->Lines,DataKey);
      Type = tMessage;

      SetMessage();
      Caption = GetParam(0,DataKey,PS.c_str())+": "+GetParam(1,DataKey,PS.c_str());
      if (locked) LockWindowUpdate(0);
      ok = true;
   }
   return ok;
}
//---------------------------------------------------------------------------
void __fastcall TMessageInWin::OkBtnClick(TObject *Sender)
{
//   if (!Editor->Modified || (Editor->Modified && Save()))
      Close();
}
//---------------------------------------------------------------------------
void __fastcall TMessageInWin::WordWrapClick(TObject *Sender)
{
   bool locked = LockWindowUpdate(Handle);
   Editor->WordWrap = WordWrap->Checked;
   if (locked) LockWindowUpdate(0);
}
//---------------------------------------------------------------------------
void __fastcall TMessageInWin::EditBtnClick(TObject *Sender)
{
   SetEditMode(EditBtn->Down);
}
//---------------------------------------------------------------------------
void __fastcall TMessageInWin::NoHeadersClick(TObject *Sender)
{
   if (NoHeaders->Checked) HeadersBtn->Visible = false;
   else HeadersBtn->Visible = true;
   SetMessage();
}
//---------------------------------------------------------------------------
void __fastcall TMessageInWin::SetEditMode(bool Editing)
{
   if (Editing)
   {
      Editor->ReadOnly = false;
      ReplyBtn->Enabled = false;
      NoHeaders->Checked = false;
      NoHeaders->Enabled = false;
      WordWrap->Checked = false;
      WordWrap->Enabled = false;
      HeadersBtn->Down = true;
      FullHeaders = true;
      SetMessage();
   }
   else
   {
      if (!CheckSave())
      {
         EditBtn->Down = true;
         return;
      }
      SetMessage();
      HeadersBtn->Down = false;
      Editor->ReadOnly = true;
      NoHeaders->Enabled = true;
      WordWrap->Enabled = true;
      ReplyBtn->Enabled = true;
   }
}
//---------------------------------------------------------------------------
void __fastcall TMessageInWin::PGPcdecBtnClick(TObject *Sender)
{
   AnsiString pswd;
   if (!PGPgetDecryptionPassphrase(pswd)) return;
   TDataBuf *password = new TDataBuf(pswd.c_str(),pswd.Length());
   for (int i=1; i<pswd.Length(); i++) pswd[i] = ' '; pswd = "";

   TStringList *fullmsg = new TStringList();
   TStringList *pgpblock = new TStringList();
   GetAppData(fullmsg,DataKey);
   fullmsg->Add(""); // so inserts can be made without checks
   int i,cnt,end,start = fullmsg->IndexOf("-----BEGIN PGP MESSAGE-----");
   if (start) end = fullmsg->IndexOf("-----END PGP MESSAGE-----");
   if (start>=0 && end>start)
   {
      for (i=start; i<=end; i++) pgpblock->Add(fullmsg->Strings[i]);
      if (PgpDecryptConventional(pgpblock,password)==mrOk)
      {
         pgpblock->Insert(0,"-----BEGIN PGP DECRYPTED MESSAGE-----");
         pgpblock->Add("-----END PGP DECRYPTED MESSAGE-----");
         cnt = end-(start-1);
         for (i=0; i<cnt; i++) if (i<fullmsg->Count) fullmsg->Delete(start);
         for (i=0; i<pgpblock->Count; i++) fullmsg->Insert(start+i,pgpblock->Strings[i]);
         fullmsg->Delete(fullmsg->Count-1); // dump the trailing null line
         Editor->Clear();

         bool locked = LockWindowUpdate(Handle);
         Editor->Lines->Text = fullmsg->Text;
         Editor->Perform(EM_LINESCROLL,0,start);
         Editor->SelStart = Editor->Perform(EM_LINEINDEX,start,NULL);
         Sleep(200);
         HeadersBtn->Down = true;
         EditBtn->Down = true;
         PGPcdecBtn->Enabled = false;
         if (locked) LockWindowUpdate(0);
      }
      else
         MsgBoxHwnd(Handle,"Unable to decrypt message!","QuickSilver",MB_OK);
   }
   else
   {
      MsgBoxHwnd(Handle,
        AnsiString("Unable to decrypt message!\n\n")+
        AnsiString("This message has some appearances of being\n")+
        AnsiString("PGP encrypted, but I have found a problem in\n")+
        AnsiString("the beginning and/or ending PGP markers."),
       "PGP Error",MB_OK
      );
   }
   delete pgpblock;
   delete fullmsg;
   delete password;
}
//---------------------------------------------------------------------------
void __fastcall TMessageInWin::SaveBtnClick(TObject *Sender)
{
  TPoint cpoint,poppoint={ -1,24 };
  cpoint = OkBtn->ClientToScreen(poppoint);
  PopupMenu1->Popup(cpoint.x,cpoint.y);
}
//---------------------------------------------------------------------------
void __fastcall TMessageInWin::PopupMenu1Popup(TObject *Sender)
{
   PopupSaveItem->Enabled = Editor->Modified;
}
//---------------------------------------------------------------------------
void __fastcall TMessageInWin::PopupSaveItemClick(TObject *Sender)
{
   Save();
}
//---------------------------------------------------------------------------
void __fastcall TMessageInWin::PopupSaveasItemClick(TObject *Sender)
{
   SaveAs();
}
//---------------------------------------------------------------------------
void __fastcall TMessageInWin::TransferMessageTo(AnsiString &Boxname)
{
   if (Boxname.IsEmpty()) return;
   AnsiString NewDataKey=UserMailboxes+PS+Boxname+PS+IndexStr;
   PutAppData(NewDataKey,Editor->Lines);
   PutAppData(DataKey,NULL);
   DataKey = NewDataKey;
   Mailbox = Boxname;
   SetMessage();
}
//---------------------------------------------------------------------------
void __fastcall TMessageInWin::CopyMessageTo(AnsiString &Boxname)
{
   if (Boxname.IsEmpty()) return;
   DataKey=UserMailboxes+PS+Boxname+PS+IndexStr;
   PutAppData(DataKey,Editor->Lines);
   Mailbox = Boxname;
   SetMessage();
}
//---------------------------------------------------------------------------
void __fastcall TMessageInWin::PopupTransferItemClick(TObject *Sender)
{
   AnsiString Oldbox=Mailbox,Newbox = GetTransferBoxname("");
   if (Newbox.IsEmpty()) return;

   TransferMessageTo(Newbox);
   // check to see if boxes are on desktop
   TMailboxWin *mbw=FindOpenMailbox(Oldbox);
   if (mbw!=NULL) mbw->RefreshIndex();
   mbw=FindOpenMailbox(Newbox);
   if (mbw!=NULL) mbw->RefreshIndex();
}
//---------------------------------------------------------------------------
void __fastcall TMessageInWin::PopupCopyItemClick(TObject *Sender)
{
   AnsiString Oldbox=Mailbox,Newbox=GetTransferBoxname("");
   if (Newbox.IsEmpty()) return;

   CopyMessageTo(Newbox);
   // check to see if boxes are on desktop
   TMailboxWin *mbw=FindOpenMailbox(Newbox);
   if (mbw!=NULL) mbw->RefreshIndex();
}
//---------------------------------------------------------------------------
void __fastcall TMessageInWin::PopupDeleteItemClick(TObject *Sender)
{
   if (MsgBox("Delete this message from the QS database?","Confirm",MB_OKCANCEL)==IDOK)
   {
      Editor->Clear(); Caption=" deleting message..."; Sleep(500);
      Application->ProcessMessages();
      PutAppData(DataKey,NULL);

      TMailboxWin *mbw=FindOpenMailbox(Mailbox);
      if (mbw!=NULL) mbw->RefreshIndex();

      Editor->Modified = false;
      Close();
   }
}
//---------------------------------------------------------------------------
