//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#include <vcl\registry.hpp>
#pragma hdrstop

#include "PgpPass.h"
#include "Version.h"
#include "Global.h"
#include "mixmastdlg.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TPgpPassForm *PgpPassForm;
//---------------------------------------------------------------------------
bool __fastcall PGPgetKeynameAndPassPhrase(AnsiString &Keyid, TDataBuf *Passphrase)
{
   AnsiString s;
   bool ok = false;
   TPgpPassForm *pf = new TPgpPassForm(Application->MainForm);
   TStrings *items = pf->Keyid->Items;
   TStringList *tmp = new TStringList();
   if (FileExists(HomeVarsText)) tmp->LoadFromFile(HomeVarsText);
   int i=0; while ((s=tmp->Values["sk"+AnsiString(++i)])!="")
      items->Add(s);
   delete tmp;
   for (i=0; i<items->Count; i++)
   {
      if (items->Text.Pos(Keyid))
      {
         pf->Keyid->ItemIndex = i;
         pf->ActiveControl = pf->Passphrase;
         break;
      }
   }
   pf->ShowModal();
   if (pf->ModalResult==mrOk)
   {
      Keyid = pf->Keyid->Text;
      Keyid = Keyid.SubString(1,Keyid.Pos("(RSA")-1).TrimRight();
      Passphrase->Set(pf->Passphrase->Text.c_str(),pf->Passphrase->Text.Length());
      Passphrase->Encrypt(BUFWORD);
      ok = true;
   }
   delete pf;
   return ok;
}
//---------------------------------------------------------------------------
__fastcall TPgpPassForm::TPgpPassForm(TComponent* Owner)
  : TForm(Owner)
{
   TRegistry *reg = new TRegistry();
   if (reg->OpenKey(QuickKey,false))
      HideTypeBox->Checked = reg->ReadBool("Hide Password");
   delete reg;
   Passphrase->PasswordChar = HideTypeBox->Checked ? '*' : '\0';
   CenterDialog(this,Application->MainForm);
}
//---------------------------------------------------------------------------
void __fastcall TPgpPassForm::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   if (ModalResult==mrOk && (Passphrase->Text.IsEmpty() || Keyid->Text.IsEmpty()))
   {
      MsgBoxHwnd(Handle,"Signing key and passphrase both required","Input Problem",MB_OK);
      ClearText();
      CanClose = false;
   }
}
//---------------------------------------------------------------------------
void __fastcall TPgpPassForm::FormDestroy(TObject *Sender)
{
   ClearText();
}
//---------------------------------------------------------------------------
void __fastcall TPgpPassForm::ClearText()
{
   for (int i=1; i<=Passphrase->Text.Length(); i++) Passphrase->Text[i] = '\0';
   Passphrase->Clear();
}
//---------------------------------------------------------------------------
void __fastcall TPgpPassForm::HideTypeBoxClick(TObject *Sender)
{
   Passphrase->PasswordChar = HideTypeBox->Checked ? '*' : '\0';
   TRegistry *reg = new TRegistry();
   if (reg->OpenKey(QuickKey,false)) reg->WriteBool("Hide Password",HideTypeBox->Checked);
   delete reg;
}
//---------------------------------------------------------------------------
