#define _WINSOCKAPI_
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#include <filectrl.hpp>
#pragma hdrstop

#include "UPDFtpDlg.h"
#include "global.h""
//---------------------------------------------------------------------------
#pragma link "Ftpcli"
#pragma resource "*.dfm"
TUPDftpDlg *UPDftpDlg;
#define TEMP_FILE_NAME "FTPDir.TXT"
//---------------------------------------------------------------------------
bool __fastcall GetQSUpdateList(TComponent *Owner, TStrings *Commands, TStrings *FileList)
{
   bool ok=false;
   FileList->Clear();
   UPDftpDlg = new TUPDftpDlg(Owner);
   UPDftpDlg->FTP->Port = Commands->Values["HostPort"];
   UPDftpDlg->FTP->HostDirName = Commands->Values["HostDir"];
   UPDftpDlg->FTP->HostName = Commands->Values["HostName"];
   UPDftpDlg->FTP->UserName = Commands->Values["UserName"];
   UPDftpDlg->FTP->PassWord = Commands->Values["Password"];
   UPDftpDlg->FTP->Passive = Commands->Values["Passive"]=="1";
   if (UPDftpDlg->GetUpdateList()==mrOk && FileExists(TEMP_FILE_NAME))
   {
      TStringList *tmp = new TStringList();
      UPDftpDlg->ParseFileList(tmp);
      FileList->Text = tmp->Text;
      delete tmp;
      ok = true;
   }
   if (FileExists(TEMP_FILE_NAME)) DeleteFile(TEMP_FILE_NAME);
   delete UPDftpDlg;
   return ok;
}
//---------------------------------------------------------------------------
bool __fastcall GetQSUpdate(TComponent *Owner, TStrings *Commands)
{
   bool ok=false;
   AnsiString LocalFileName = Commands->Values["LocalFileName"];
   UPDftpDlg = new TUPDftpDlg(Owner);
   UPDftpDlg->FTP->Port = Commands->Values["HostPort"];
   UPDftpDlg->FTP->HostDirName = Commands->Values["HostDir"];
   UPDftpDlg->FTP->HostName = Commands->Values["HostName"];
   UPDftpDlg->FTP->UserName = Commands->Values["UserName"];
   UPDftpDlg->FTP->PassWord = Commands->Values["Password"];
   UPDftpDlg->FTP->Passive = Commands->Values["Passive"]=="1";
   UPDftpDlg->FTP->HostFileName = Commands->Values["HostFileName"];
   UPDftpDlg->FTP->LocalFileName = LocalFileName;
   UPDftpDlg->Filesize = Commands->Values["FileSize"].ToIntDef(0);
   if (UPDftpDlg->GetUpdate()==mrOk && FileExists(LocalFileName))
   {
      ok=true;
   }
   delete UPDftpDlg;
   return ok;
}
//---------------------------------------------------------------------------
__fastcall TUPDftpDlg::TUPDftpDlg(TComponent *Owner)
   : TForm(Owner)
{
   AnsiString host;
   CenterDialog(this,(TForm*)Owner);
   FTP->PassWord = "nobody@nowhere.net";
   FTP->UserName = "anonymous";
   FTP->Port = "ftp";
   BytesTotal = 0;
   Cancel = false;
   Label1->Caption = "";
}
//---------------------------------------------------------------------------
int __fastcall TUPDftpDlg::GetUpdateList()
{
   Display->Clear();
   Display->Lines->Add("Connecting...");
   FTP->LocalFileName = TEMP_FILE_NAME;
   FTP->DirectoryAsync();
   return ShowModal();
}
//---------------------------------------------------------------------------
int __fastcall TUPDftpDlg::GetUpdate()
{
   Display->Clear();
   Display->Lines->Add("Connecting...");
   BytesTotal = Filesize;
   FTP->ReceiveAsync();
   return ShowModal();
}
//---------------------------------------------------------------------------
void __fastcall TUPDftpDlg::ParseFileList(TStringList *Results)
{
   Results->Clear();
   AnsiString name,size,entry,ext;
   if (FileExists(TEMP_FILE_NAME))
   {
      TStringList *dir = new TStringList();
      dir->LoadFromFile(TEMP_FILE_NAME); DeleteFile(TEMP_FILE_NAME);
      for (int i=0; i<dir->Count; i++)
      {
         entry=dir->Strings[i];
         name=GetParam(8,entry," "); ext=ExtractFileExt(name);
         if (name.SubString(1,2)!="QS" || (ext!=".exe" && ext!=".zip")) continue;

         size=GetParam(4,entry," ");
         while (size.Length()< 8) size = " "+size;
         while (name.Length()<11) name += " ";
         Results->Add(name+" "+size);
      }
      delete dir;
   }
}
//---------------------------------------------------------------------------
void __fastcall TUPDftpDlg::FTPRequestDone(TObject *Sender, TFtpRequest RqType, WORD Error)
{
   AnsiString tmp,name;
   LastError = Error;
   if (Error)
   {
      FTPDisplay(Sender,"Error = " + IntToStr(Error) + " (" + FTP->ErrorMessage + ")");
      CancelBtn->Caption = "Close";
      return;
   }
   switch (RqType)
   {
      case ftpListAsync:
      case ftpDirectoryAsync:
         if (Cancel || LastError)
         {
            if (FileExists(TEMP_FILE_NAME)) DeleteFile(TEMP_FILE_NAME);
            MyBeep(MB_ICONHAND);
            break;
         }
         ModalResult = mrOk;
         Finished = true;
         //MyBeep(MB_OK);
         //Sleep(1000);
         break;
      case ftpReceiveAsync:
         if (Cancel || LastError)
         {
            if (BytesReceived<BytesTotal && FileExists(FTP->LocalFileName))
            {
               Display->Lines->Add("Deleting "+ExtractFileName(FTP->LocalFileName)+"...");
               DeleteFile(FTP->LocalFileName.c_str());
            }
            MyBeep(MB_ICONHAND);
            break;
         }
         ModalResult = mrOk;
         Finished = true;
         //MyBeep(MB_OK);
         //Sleep(1000);
         break;
   }
}
//---------------------------------------------------------------------------
void __fastcall TUPDftpDlg::FTPDisplay(TObject *Sender, AnsiString &Msg)
{
   if (!Cancel) Display->Lines->Add(Msg);
}
//---------------------------------------------------------------------------
void __fastcall TUPDftpDlg::FTPProgress(TObject *Sender, long Count, bool &Abort)
{
   if (Cancel) Abort = true;
   if (!Abort && BytesTotal>0)
   {
      Label1->Caption = AnsiString((int)Count)+" of "+AnsiString(BytesTotal)+" bytes ";
      ProgressBar1->Position = (Count/BytesTotal)*100;
      BytesReceived = Count;
   }
}
//---------------------------------------------------------------------------
void __fastcall TUPDftpDlg::CancelBtnClick(TObject *Sender)
{
   FTP->Abort();
   if (CancelBtn->Caption=="Cancel")
   {
      Display->Lines->Add("");
      Display->Lines->Add("User cancelled operation...");
      MyBeep(MB_ICONHAND);
      Cancel = true;
      Sleep(1000);
   }
   ModalResult = mrCancel;
}
//---------------------------------------------------------------------------
void __fastcall TUPDftpDlg::FTPSessionClosed(TObject *Sender, WORD Error)
{
/*   LastError = Error;
   if (Cancel)
   {
      Display->Lines->Add("");
      Display->Lines->Add("User cancelled operation...");
      MyBeep(MB_ICONHAND);
      Sleep(1000);
      ModalResult = mrCancel;
   }   */
}
//---------------------------------------------------------------------------
void __fastcall TUPDftpDlg::FTPSessionConnected(TObject *Sender, WORD Error)
{
//   Display->Lines->Add("Connected");
}
//---------------------------------------------------------------------------
